

;*******************************************************************************	
;		__bmul(unsigned char multiplier, unsigned char multiplicand)
;*******************************************************************************
	
__bmul:
	MOVWF	multiplier
	CLRF	product			;unsigned char product = 0;
A8E:	
	BTFSS	multiplier, 0x0		; if(multiplier & 1)
	GOTO	A96
	MOVF	__pcstackCOMMON, W	; product += multiplicand;
	ADDWF	product, F
A96: 
	BCF	STATUS, 0x0		; multiplicand <<= 1;
	RLF	__pcstackCOMMON, F
	BCF	STATUS, 0x0		; multiplier >>= 1;
	RRF	multiplier, F
	MOVF	multiplier, W		;} while(multiplier != 0);
	BTFSS	STATUS, 0x2
	GOTO	A8E
	MOVF	product, W		;return product;
	RETURN

;--  /opt/microchip/xc8/v2.20/pic/sources/c90/common/awmod.c  ------------------
;             // integer signed unsigned modulus
;             
;             signed int
;             #ifdef __PICC__
;             __awmod(signed int divisor, signed int dividend)
;             #else
;             __awmod(signed int dividend, signed int divisor)
;             #endif
;             {
;            	unsigned char	counter, sign;
;            
__awmod:
	
;AF1E:
	CLRF sign		; sign = 0;
; if(dividend < 0) {
	BTFSS LCD_Char, 0x7
	GOTO AF28
; dividend = -dividend;
	COMF dividend, F
	COMF LCD_Char, F
	INCF dividend, F
	BTFSC STATUS, 0x2
	INCF LCD_Char, F
; sign = 1;
	CLRF sign
	INCF sign, F
; }
; f(divisor < 0)
AF28:
	BTFSS n, 0x7
	GOTO AF2F
; divisor = -divisor;
	COMF __pcstackCOMMON, F
	COMF n, F
	INCF __pcstackCOMMON, F
	BTFSC STATUS, 0x2
	INCF n, F
; if(divisor != 0) {
AF2F:
	MOVF __pcstackCOMMON, W
	IORWF n, W
	BTFSC STATUS, 0x2
	GOTO AF56
; counter = 1;
	CLRF counter
	INCF counter, F
; while(((unsigned int)divisor & 0x8000U) == 0) {
AF35:
	BTFSC n, 0x7
	GOTO AF41
	GOTO AF35
; divisor <<= 1;
	MOVLW 0x1
AF38:
	LSLF __pcstackCOMMON, F
	RLF n, F
	DECFSZ WREG, F
	GOTO AF38
; counter++;
	MOVLW 0x1
	MOVWF row
	MOVF row, W
	ADDWF counter, F
; }
; do {
; if((unsigned int)divisor <= (unsigned int)dividend)
AF41:
	MOVF n, W
	SUBWF LCD_Char, W
	BTFSS STATUS, 0x2
	GOTO AF47
	MOVF __pcstackCOMMON, W
	SUBWF dividend, W
	
AF47:
	BTFSS STATUS, 0x0
	GOTO AF4D
; dividend -= divisor;
	MOVF __pcstackCOMMON, W
	SUBWF dividend, F
	MOVF n, W
	SUBWFB LCD_Char, F
; *(unsigned int *)&divisor >>= 1;
AF4D:	
	MOVLW 0x1
AF4E:
	LSRF n, F
	RRF __pcstackCOMMON, F
	DECFSZ WREG, F
	GOTO AF4E
; } while(--counter != 0);
	MOVLW 0x1
	SUBWF counter, F
	BTFSS STATUS, 0x2
	GOTO AF41
; }
; if(sign)
AF56:
	MOVF sign, W
	BTFSC STATUS, 0x2
	GOTO AF5E
; dividend = -dividend;
	COMF dividend, F
	COMF LCD_Char, F
	INCF dividend, F
	BTFSC STATUS, 0x2
	INCF LCD_Char, F
; return dividend;
AF5E:	MOVF LCD_Char, W
	MOVWF n
	MOVF dividend, W
	MOVWF __pcstackCOMMON
	RETURN

;---  /opt/microchip/xc8/v2.20/pic/sources/c90/common/awdiv.c  -----------------
;             // integer signed division
;             
;             signed int
;             #ifdef __PICC__
;             __awdiv(signed int divisor, signed int dividend)
;             #else
;             __awdiv(signed int dividend, signed int divisor)
;             #endif
;             {
;            	signed int	quotient;
;            	unsigned char	counter, sign;
;            
__awdiv:	; Dividend : Divisor = Quotient
	
;A7AB:
	CLRF	sign			; sign = 0;
	BTFSS	n, 0x7			; if(divisor < 0) Note:signed int=10000000 = -128!
	GOTO	A7B5
	COMF	__pcstackCOMMON, F	; divisor = -divisor;
	COMF	n, F
	INCF	__pcstackCOMMON, F
	BTFSC	STATUS, 0x2
	INCF	n, F
	CLRF	sign	
	INCF	sign, F			; sign = 1;
A7B5:
	BTFSS	LCD_Char, 0x7		; if(dividend < 0) {
	GOTO	A7C0
	COMF	dividend, F		; dividend = -dividend;
	COMF	LCD_Char, F
	INCF	dividend, F
	BTFSC	STATUS, 0x2
	INCF	LCD_Char, F
	MOVLW	0x1			; sign ^= 1;
	MOVWF	row
	MOVF	row, W
	XORWF	sign, F
A7C0:
	CLRF	quotient		; quotient = 0;
	CLRF	0x78
	MOVF	__pcstackCOMMON, W	; if(divisor != 0) {
	IORWF	n, W
	BTFSC	STATUS, 0x2
	GOTO	A7EF
	CLRF	counter
	INCF	counter, F		; counter = 1;

A7C8:	
	BTFSC	n, 0x7			; while((divisor & 0x8000U) == 0) {
	GOTO	A7D4
	GOTO	A7C8
	MOVLW	0x1			; divisor <<= 1;
A7CB:	
	LSLF	__pcstackCOMMON, F
	RLF	n, F
	DECFSZ	WREG, F
	GOTO	A7CB
	MOVLW	0x1			; counter++;
	MOVWF	row
	MOVF	row, W
	ADDWF	counter, F
A7D4:
	MOVLW	0x1	; quotient <<= 1;
A7D5:  
	LSLF	quotient, F
	RLF	0x78, F
	DECFSZ	WREG, F
	GOTO	A7D5
; if((unsigned int)divisor <= (unsigned int)dividend) {
	MOVF	n, W
	SUBWF	LCD_Char, W
	BTFSS	STATUS, 0x2
	GOTO	A7DF
	MOVF	__pcstackCOMMON, W
	SUBWF	dividend, W
A7DF:	
	BTFSS	STATUS, 0x0
	GOTO	A7E6
	MOVF	__pcstackCOMMON, W	; dividend -= divisor;
	SUBWF	dividend, F
	MOVF	n, W
	SUBWFB	LCD_Char, F
	BSF	quotient, 0x0	; quotient |= 1;

A7E6:
	MOVLW	0x1	; *(unsigned int *)&divisor >>= 1;
A7E7:	
	LSRF	n, F
	RRF	__pcstackCOMMON, F
	DECFSZ	WREG, F
	GOTO	A7E7
	MOVLW	0x1	; } while(--counter != 0);
	SUBWF	counter, F
	BTFSS	STATUS, 0x2
	GOTO	A7D4
A7EF:	
	MOVF	sign, W	; if(sign)
	BTFSC	STATUS, 0x2
	GOTO	A7F7
	COMF	quotient, F	; quotient = -quotient;
	COMF	0x78, F
	INCF	quotient, F
	BTFSC	STATUS, 0x2
	INCF	0x78, F
A7F7:	
	MOVF	0x78, W	; return quotient;
	MOVWF	n
	MOVF	quotient, W
	MOVWF	__pcstackCOMMON
	RETURN
	